#include "shellscrollbar.h"
#include "sparrowshell.h"
#include "mesh.h"
#include "phongmaterial.h"
#include "scene/meshnode.h"
#include "tools/utils.h"
#include <iostream>


ShellScrollBar::ShellScrollBar(Mesh *mesh, SparrowShell *shell, glm::ivec2 dim):
    MeshNode(mesh,false), m_shell(shell),m_dimension(dim)
{
    m_position = glm::vec2(m_shell->getDimension().x-SparrowShell::SCROLLBAR_PIXEL_WIDTH,0);
    moveTo2D(m_position);
}

void ShellScrollBar::update(){
    MeshNode::update();
//    m_position.y = m_shell->getPosition().y;
//    m_dimension.y = m_shell->getDimension().y;
    int size = m_shell->getBuffer()->size();
    float cran = ((float)m_shell->getDimension().y/(float)size);
    int indexCursor = size - (m_shell->getIndex()+SparrowShell::BUFFER_DISPLAYED_LINES);

    if (m_shell->isBufferResized()){
//        std::cout << size << std::endl;
//        std::cout << cran * SparrowShell::BUFFER_DISPLAYED_LINES << std::endl;
        glm::ivec2 new_dim(m_dimension.x,(int)(cran * SparrowShell::BUFFER_DISPLAYED_LINES));
        resize2D(m_dimension,new_dim);
        m_dimension = new_dim;
    }
    if (m_shell->isBufferResized() || m_shell->indexMoved())
    {
//        std::cout << m_position.x << " " << cran*indexCursor << std::endl;
        glm::ivec2 new_pos((int)m_position.x, (int) cran * indexCursor);
        moveTo2D(new_pos);
    }
}
